var $AdfDomUtils$$ = {};
$goog$exportSymbol$$("AdfDomUtils", $AdfDomUtils$$);
$AdfDomUtils$$.$isVisible$ = function $$AdfDomUtils$$$$isVisible$$($domElement$$584$$) {
  return null == $domElement$$584$$ ? !1 : "none" != $domElement$$584$$.style.display;
};
$goog$exportSymbol$$("AdfDomUtils.isVisible", $AdfDomUtils$$.$isVisible$);
$AdfDomUtils$$.$isInVisibleSubtree$ = function $$AdfDomUtils$$$$isInVisibleSubtree$$($node$$139$$) {
  if (null == $node$$139$$) {
    return !1;
  }
  for (;null != $node$$139$$;) {
    if ($node$$139$$.style && "none" == $node$$139$$.style.display) {
      return !1;
    }
    $node$$139$$ = $node$$139$$.parentNode;
  }
  return !0;
};
$goog$exportSymbol$$("AdfDomUtils.isInVisibleSubtree", $AdfDomUtils$$.$isInVisibleSubtree$);
$AdfDomUtils$$.$stripScripts$ = function $$AdfDomUtils$$$$stripScripts$$($domElement$$585$$) {
  var $children$$71$$ = $domElement$$585$$.childNodes;
  if (null != $children$$71$$) {
    for (var $textNode$$2$$ = null, $i$$685$$ = $children$$71$$.length - 1;-1 < $i$$685$$;$i$$685$$--) {
      $textNode$$2$$ = $children$$71$$[$i$$685$$], 1 == $textNode$$2$$.nodeType && "SCRIPT" == $textNode$$2$$.tagName && $domElement$$585$$.removeChild($textNode$$2$$);
    }
  }
};
$goog$exportSymbol$$("AdfDomUtils.stripScripts", $AdfDomUtils$$.$stripScripts$);
$AdfDomUtils$$.setVisible = function $$AdfDomUtils$$$setVisible$($domElement$$586$$, $visible$$5$$) {
  $AdfAssert$$.assert(null != $domElement$$586$$);
  $domElement$$586$$.style.display = "true" === $visible$$5$$ || !0 === $visible$$5$$ ? "" : "none";
};
$goog$exportSymbol$$("AdfDomUtils.setVisible", $AdfDomUtils$$.setVisible);
$AdfDomUtils$$.$getOffsetSizeFromCssLength$ = function $$AdfDomUtils$$$$getOffsetSizeFromCssLength$$($container$$68$$, $cssLength$$2$$) {
  if (-1 != $cssLength$$2$$.indexOf("px")) {
    return parseInt($cssLength$$2$$, 10);
  }
  var $div$$21$$ = $container$$68$$.ownerDocument.createElement("div");
  try {
    $div$$21$$.style.width = $cssLength$$2$$;
  } catch ($e$$155$$) {
    $AdfLogger$$.$LOGGER$.fine("Exception while trying to  style width to: " + $cssLength$$2$$);
  }
  $container$$68$$.appendChild($div$$21$$);
  var $offset$$19$$ = $div$$21$$.offsetWidth;
  $container$$68$$.removeChild($div$$21$$);
  return $offset$$19$$;
};
$goog$exportSymbol$$("AdfDomUtils.getOffsetSizeFromCssLength", $AdfDomUtils$$.$getOffsetSizeFromCssLength$);
$AdfDomUtils$$.$isNodeInDocumentHierarchy$ = function $$AdfDomUtils$$$$isNodeInDocumentHierarchy$$($domDocument$$70$$, $node$$140$$) {
  $AdfAssert$$.$assertDomNode$($domDocument$$70$$);
  $AdfAssert$$.$assertDomNode$($node$$140$$);
  if ($node$$140$$ == $domDocument$$70$$) {
    return !0;
  }
  if ($domDocument$$70$$ == $node$$140$$.ownerDocument) {
    for (;null != $node$$140$$;) {
      if ($node$$140$$ = $node$$140$$.parentNode, $node$$140$$ == $domDocument$$70$$) {
        return !0;
      }
    }
  }
  return !1;
};
$goog$exportSymbol$$("AdfDomUtils.isNodeInDocumentHierarchy", $AdfDomUtils$$.$isNodeInDocumentHierarchy$);
$AdfDomUtils$$.$isAncestor$ = function $$AdfDomUtils$$$$isAncestor$$($ancestorNode$$4$$, $node$$141$$) {
  if (null != $node$$141$$) {
    for (var $parentNode$$21$$ = $node$$141$$ ? $node$$141$$.parentNode : null;$parentNode$$21$$;) {
      if ($parentNode$$21$$ == $ancestorNode$$4$$) {
        return !0;
      }
      $parentNode$$21$$ = $parentNode$$21$$.parentNode;
    }
  }
  return !1;
};
$goog$exportSymbol$$("AdfDomUtils.isAncestor", $AdfDomUtils$$.$isAncestor$);
$AdfDomUtils$$.$isAncestorOrSelf$ = function $$AdfDomUtils$$$$isAncestorOrSelf$$($ancestorNode$$5$$, $node$$142$$) {
  return $node$$142$$ == $ancestorNode$$5$$ ? !0 : $AdfDomUtils$$.$isAncestor$($ancestorNode$$5$$, $node$$142$$);
};
$AdfDomUtils$$.isAncestorOrSelf = $AdfDomUtils$$.$isAncestorOrSelf$;
$goog$exportSymbol$$("AdfDomUtils.isAncestorOrSelf", $AdfDomUtils$$.$isAncestorOrSelf$);
$AdfDomUtils$$.$getNodeDistance$ = function $$AdfDomUtils$$$$getNodeDistance$$($nodeA$$, $nodeB$$) {
  if ($nodeA$$ == $nodeB$$) {
    return 0;
  }
  var $commonAncestor_distance$$3$$ = 0, $parentNode$$22$$;
  if ($AdfDomUtils$$.$isAncestor$($nodeA$$, $nodeB$$)) {
    for ($parentNode$$22$$ = $nodeB$$.parentNode;$parentNode$$22$$;) {
      $commonAncestor_distance$$3$$++;
      if ($parentNode$$22$$ == $nodeA$$) {
        return $commonAncestor_distance$$3$$;
      }
      $parentNode$$22$$ = $parentNode$$22$$.parentNode;
    }
  } else {
    if ($AdfDomUtils$$.$isAncestor$($nodeB$$, $nodeA$$)) {
      for ($parentNode$$22$$ = $nodeA$$.parentNode;$parentNode$$22$$;) {
        $commonAncestor_distance$$3$$++;
        if ($parentNode$$22$$ == $nodeB$$) {
          return $commonAncestor_distance$$3$$;
        }
        $parentNode$$22$$ = $parentNode$$22$$.parentNode;
      }
    }
  }
  return ($commonAncestor_distance$$3$$ = $AdfDomUtils$$.$getCommonAncestor$($nodeA$$, $nodeB$$)) ? $AdfDomUtils$$.$getNodeDistance$($commonAncestor_distance$$3$$, $nodeA$$) + $AdfDomUtils$$.$getNodeDistance$($commonAncestor_distance$$3$$, $nodeB$$) : Number.POSITIVE_INFINITY;
};
$goog$exportSymbol$$("AdfDomUtils.getNodeDistance", $AdfDomUtils$$.$getNodeDistance$);
$AdfDomUtils$$.$getCommonAncestor$ = function $$AdfDomUtils$$$$getCommonAncestor$$($nodeA$$1$$, $nodeB$$1$$) {
  if ($nodeA$$1$$ == $nodeB$$1$$) {
    return $nodeA$$1$$;
  }
  for (var $parentNode$$23$$ = $nodeA$$1$$;$parentNode$$23$$;) {
    if ($AdfDomUtils$$.$isAncestor$($parentNode$$23$$, $nodeB$$1$$)) {
      return $parentNode$$23$$;
    }
    $parentNode$$23$$ = $parentNode$$23$$.parentNode;
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getCommonAncestor", $AdfDomUtils$$.$getCommonAncestor$);
$AdfDomUtils$$.$getFormElement$ = function $$AdfDomUtils$$$$getFormElement$$($node$$143$$) {
  $AdfAssert$$.$assertDomNode$($node$$143$$);
  for (var $ourDocument$$2$$ = $node$$143$$.ownerDocument, $agent$$763$$ = $AdfAgent$$.$AGENT$;$node$$143$$ != $ourDocument$$2$$;) {
    if ("FORM" == $agent$$763$$.$getNodeName$($node$$143$$)) {
      return $node$$143$$;
    }
    $node$$143$$ = $node$$143$$.parentNode;
    $AdfAssert$$.assert($node$$143$$, "Should never get this far with disconnected DOM");
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getFormElement", $AdfDomUtils$$.$getFormElement$);
$AdfDomUtils$$.$getInputFileForm$ = function $$AdfDomUtils$$$$getInputFileForm$$($actionForm$$10$$) {
  for (var $inputs$$3$$ = $actionForm$$10$$.getElementsByTagName("input"), $inputCount$$ = $inputs$$3$$.length, $multiPartForm$$3$$ = null, $i$$686$$ = 0;$i$$686$$ < $inputCount$$;++$i$$686$$) {
    var $inputElem$$1$$ = $inputs$$3$$[$i$$686$$];
    if ("file" == $inputElem$$1$$.type && ($inputElem$$1$$.value || "true" == $inputElem$$1$$.getAttribute("_afrMultiFileUpload"))) {
      $multiPartForm$$3$$ = $actionForm$$10$$;
      break;
    }
  }
  return $multiPartForm$$3$$;
};
$goog$exportSymbol$$("AdfDomUtils.getInputFileForm", $AdfDomUtils$$.$getInputFileForm$);
$AdfDomUtils$$.$isMultiPartForm$ = function $$AdfDomUtils$$$$isMultiPartForm$$($enctype_formElement$$9$$) {
  $enctype_formElement$$9$$ = $enctype_formElement$$9$$.enctype;
  return null != $enctype_formElement$$9$$ && "multipart/form-data" == $enctype_formElement$$9$$.toLowerCase() ? !0 : !1;
};
$goog$exportSymbol$$("AdfDomUtils.isMultiPartForm", $AdfDomUtils$$.$isMultiPartForm$);
$AdfDomUtils$$.$getFormElementValue$ = function $$AdfDomUtils$$$$getFormElementValue$$($formElement$$10$$, $formElementName$$) {
  for (var $elements$$25_opts$$ = [], $formElements$$2_value$$269$$ = $formElement$$10$$.elements, $first$$17_i$$687$$ = 0, $size$$68$$ = $formElements$$2_value$$269$$.length;$first$$17_i$$687$$ < $size$$68$$;++$first$$17_i$$687$$) {
    $formElements$$2_value$$269$$[$first$$17_i$$687$$].getAttribute("name") == $formElementName$$ && $elements$$25_opts$$.push($formElements$$2_value$$269$$[$first$$17_i$$687$$]);
  }
  if (0 == $elements$$25_opts$$.length) {
    return null;
  }
  $first$$17_i$$687$$ = $elements$$25_opts$$[0];
  switch($first$$17_i$$687$$.tagName) {
    case "TEXTAREA":
      return $first$$17_i$$687$$.value;
    case "INPUT":
      switch($first$$17_i$$687$$.getAttribute("type")) {
        case "radio":
          $first$$17_i$$687$$ = 0;
          for ($size$$68$$ = $elements$$25_opts$$.length;$first$$17_i$$687$$ < $size$$68$$;++$first$$17_i$$687$$) {
            if ($elements$$25_opts$$[$first$$17_i$$687$$].checked) {
              return $elements$$25_opts$$[$first$$17_i$$687$$].value;
            }
          }
          return null;
        case "checkbox":
          if (1 == $elements$$25_opts$$.length) {
            return $first$$17_i$$687$$.checked ? $first$$17_i$$687$$.value : null;
          }
          $formElements$$2_value$$269$$ = [];
          $first$$17_i$$687$$ = 0;
          for ($size$$68$$ = $elements$$25_opts$$.length;$first$$17_i$$687$$ < $size$$68$$;++$first$$17_i$$687$$) {
            $elements$$25_opts$$[$first$$17_i$$687$$].checked && $formElements$$2_value$$269$$.push($elements$$25_opts$$[$first$$17_i$$687$$].value);
          }
          return $formElements$$2_value$$269$$;
        default:
          return $first$$17_i$$687$$.value;
      }
    ;
    case "SELECT":
      if (1 == $first$$17_i$$687$$.multiple) {
        $formElements$$2_value$$269$$ = [];
        $elements$$25_opts$$ = $first$$17_i$$687$$.options;
        $first$$17_i$$687$$ = 0;
        for ($size$$68$$ = $elements$$25_opts$$.length;$first$$17_i$$687$$ < $size$$68$$;++$first$$17_i$$687$$) {
          $elements$$25_opts$$[$first$$17_i$$687$$].selected && $formElements$$2_value$$269$$.push($elements$$25_opts$$[$first$$17_i$$687$$].value);
        }
        return 0 == $formElements$$2_value$$269$$.length ? null : $formElements$$2_value$$269$$;
      }
      return $first$$17_i$$687$$.value;
    default:
      return null;
  }
};
$goog$exportSymbol$$("AdfDomUtils.getFormElementValue", $AdfDomUtils$$.$getFormElementValue$);
$AdfDomUtils$$.$getFirstElementByTagName$ = function $$AdfDomUtils$$$$getFirstElementByTagName$$($domElement$$587$$, $tagName$$13$$) {
  if (null == $domElement$$587$$) {
    return null;
  }
  var $labelElements$$7$$ = $domElement$$587$$.getElementsByTagName($tagName$$13$$);
  return $labelElements$$7$$.length ? $labelElements$$7$$[0] : null;
};
$goog$exportSymbol$$("AdfDomUtils.getFirstElementByTagName", $AdfDomUtils$$.$getFirstElementByTagName$);
$AdfDomUtils$$.$getLastElementByTagName$ = function $$AdfDomUtils$$$$getLastElementByTagName$$($domElement$$588$$, $tagName$$14$$) {
  if (null == $domElement$$588$$) {
    return null;
  }
  var $labelElements$$8$$ = $domElement$$588$$.getElementsByTagName($tagName$$14$$);
  return $labelElements$$8$$.length ? $labelElements$$8$$[$labelElements$$8$$.length - 1] : null;
};
$goog$exportSymbol$$("AdfDomUtils.getLastElementByTagName", $AdfDomUtils$$.$getLastElementByTagName$);
$AdfDomUtils$$.$getFirstDescendentElement$ = function $$AdfDomUtils$$$$getFirstDescendentElement$$($parentElement$$19$$, $elementName$$7$$) {
  return $AdfDomUtils$$.$getDescendentElement$($parentElement$$19$$, $elementName$$7$$, 0);
};
$goog$exportSymbol$$("AdfDomUtils.getFirstDescendentElement", $AdfDomUtils$$.$getFirstDescendentElement$);
$AdfDomUtils$$.$getDescendentElement$ = function $$AdfDomUtils$$$$getDescendentElement$$($parentElement$$20$$, $elementName$$8_elements$$26$$, $index$$216$$) {
  $AdfAssert$$.$assertDomElement$($parentElement$$20$$);
  $AdfAssert$$.$assertString$($elementName$$8_elements$$26$$);
  $AdfAssert$$.$assertNumber$($index$$216$$);
  $elementName$$8_elements$$26$$ = $parentElement$$20$$.getElementsByTagName($elementName$$8_elements$$26$$);
  $AdfAssert$$.assert($elementName$$8_elements$$26$$);
  var $length$$88$$ = $elementName$$8_elements$$26$$.length;
  return $length$$88$$ > $index$$216$$ ? ($elementName$$8_elements$$26$$[0] == $parentElement$$20$$ && $length$$88$$ > $index$$216$$ + 1 && $index$$216$$++, $elementName$$8_elements$$26$$[$index$$216$$]) : null;
};
$goog$exportSymbol$$("AdfDomUtils.getDescendentElement", $AdfDomUtils$$.$getDescendentElement$);
$AdfDomUtils$$.$getFirstChildElement$ = function $$AdfDomUtils$$$$getFirstChildElement$$($parentElement$$21$$) {
  return $AdfDomUtils$$.$getFirstChildNodeByType$($parentElement$$21$$, 1);
};
$goog$exportSymbol$$("AdfDomUtils.getFirstChildElement", $AdfDomUtils$$.$getFirstChildElement$);
$AdfDomUtils$$.$getElement$ = function $$AdfDomUtils$$$$getElement$$($n$$21_node$$144$$) {
  if (null == $n$$21_node$$144$$) {
    return null;
  }
  for (;null != $n$$21_node$$144$$;$n$$21_node$$144$$ = $n$$21_node$$144$$.parentNode) {
    if (1 == $n$$21_node$$144$$.nodeType) {
      return $n$$21_node$$144$$;
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getElement", $AdfDomUtils$$.$getElement$);
$AdfDomUtils$$.$getChildElements$ = function $$AdfDomUtils$$$$getChildElements$$($childNodes$$33_parentElement$$22$$) {
  $childNodes$$33_parentElement$$22$$ = $childNodes$$33_parentElement$$22$$.childNodes;
  var $filteredNodes$$ = [];
  if ($childNodes$$33_parentElement$$22$$) {
    for (var $length$$89$$ = $childNodes$$33_parentElement$$22$$.length, $i$$688$$ = 0;$i$$688$$ < $length$$89$$;$i$$688$$++) {
      var $child$$62$$ = $childNodes$$33_parentElement$$22$$[$i$$688$$];
      1 == $child$$62$$.nodeType && $filteredNodes$$.push($child$$62$$);
    }
  }
  return $filteredNodes$$;
};
$goog$exportSymbol$$("AdfDomUtils.getChildElements", $AdfDomUtils$$.$getChildElements$);
$AdfDomUtils$$.$getLastChildElement$ = function $$AdfDomUtils$$$$getLastChildElement$$($childNodes$$34_parentElement$$23$$) {
  if ($childNodes$$34_parentElement$$23$$ = $childNodes$$34_parentElement$$23$$.childNodes) {
    for (var $i$$689$$ = $childNodes$$34_parentElement$$23$$.length - 1;0 <= $i$$689$$;$i$$689$$--) {
      var $child$$63$$ = $childNodes$$34_parentElement$$23$$[$i$$689$$];
      if (1 == $child$$63$$.nodeType) {
        return $child$$63$$;
      }
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getLastChildElement", $AdfDomUtils$$.$getLastChildElement$);
$AdfDomUtils$$.$getNonWhitespaceChildCount$ = function $$AdfDomUtils$$$$getNonWhitespaceChildCount$$($childNodes$$35_parentElement$$24$$) {
  var $childCount$$36$$ = 0;
  if ($childNodes$$35_parentElement$$24$$ = $childNodes$$35_parentElement$$24$$.childNodes) {
    for (var $length$$91$$ = $childNodes$$35_parentElement$$24$$.length, $i$$690$$ = 0;$i$$690$$ < $length$$91$$;$i$$690$$++) {
      var $childNode$$18$$ = $childNodes$$35_parentElement$$24$$[$i$$690$$], $nodeType$$7$$ = $childNode$$18$$.nodeType;
      8 != $nodeType$$7$$ && (3 == $nodeType$$7$$ ? 0 != $childNode$$18$$.data.replace(/\s*/, "").length && ++$childCount$$36$$ : 1 == $nodeType$$7$$ && (null != $childNode$$18$$.style && "none" == $childNode$$18$$.style.display || ++$childCount$$36$$));
    }
  }
  return $childCount$$36$$;
};
$goog$exportSymbol$$("AdfDomUtils.getNonWhitespaceChildCount", $AdfDomUtils$$.$getNonWhitespaceChildCount$);
$AdfDomUtils$$.$getOnlyChildElement$ = function $$AdfDomUtils$$$$getOnlyChildElement$$($childNodes$$36_parentElement$$25$$) {
  var $childElement$$24$$ = null;
  if ($childNodes$$36_parentElement$$25$$ = $childNodes$$36_parentElement$$25$$.childNodes) {
    for (var $length$$92$$ = $childNodes$$36_parentElement$$25$$.length, $i$$691$$ = 0;$i$$691$$ < $length$$92$$;$i$$691$$++) {
      childNode = $childNodes$$36_parentElement$$25$$[$i$$691$$];
      var $nodeType$$8$$ = childNode.nodeType;
      if (8 != $nodeType$$8$$) {
        if (3 == $nodeType$$8$$) {
          if (0 < childNode.data.replace(/\s*/, "").length) {
            return null;
          }
        } else {
          if (1 == $nodeType$$8$$) {
            if (null == childNode.style || "none" != childNode.style.display) {
              if ($childElement$$24$$) {
                return null;
              }
              $childElement$$24$$ = childNode;
            }
          } else {
            return null;
          }
        }
      }
    }
  }
  return $childElement$$24$$;
};
$goog$exportSymbol$$("AdfDomUtils.getOnlyChildElement", $AdfDomUtils$$.$getOnlyChildElement$);
$AdfDomUtils$$.$getInputElementsInNode$ = function $$AdfDomUtils$$$$getInputElementsInNode$$($node$$145_nodes$$33$$, $getAll$$, $elem$$57_extraTags$$) {
  var $domDoc$$12_nodeCount$$6$$ = $AdfAgent$$.$AGENT$.$getDomDocument$(), $inputElems$$1$$ = [];
  if ($domDoc$$12_nodeCount$$6$$.evaluate) {
    var $expr$$6_inputRegExp$$4_pattern$$1$$ = ".//input|.//select|.//textarea|.//button|.//a";
    if ($elem$$57_extraTags$$) {
      for (var $i$$692$$ = 0;$i$$692$$ < $elem$$57_extraTags$$.length;$i$$692$$++) {
        $expr$$6_inputRegExp$$4_pattern$$1$$ = $expr$$6_inputRegExp$$4_pattern$$1$$ + "|.//" + $elem$$57_extraTags$$[$i$$692$$];
      }
    }
    $node$$145_nodes$$33$$ = $domDoc$$12_nodeCount$$6$$.evaluate($expr$$6_inputRegExp$$4_pattern$$1$$, $node$$145_nodes$$33$$, null, XPathResult.ANY_TYPE, null);
    for ($elem$$57_extraTags$$ = $node$$145_nodes$$33$$.iterateNext();$elem$$57_extraTags$$;) {
      !$getAll$$ && ($elem$$57_extraTags$$.disabled || -1 == $elem$$57_extraTags$$.tabIndex) || "A" == $elem$$57_extraTags$$.nodeName && !$elem$$57_extraTags$$.href || $inputElems$$1$$.push($elem$$57_extraTags$$), $elem$$57_extraTags$$ = $node$$145_nodes$$33$$.iterateNext();
    }
  } else {
    $node$$145_nodes$$33$$ = $node$$145_nodes$$33$$.getElementsByTagName("*");
    $domDoc$$12_nodeCount$$6$$ = $node$$145_nodes$$33$$.length;
    $expr$$6_inputRegExp$$4_pattern$$1$$ = "^INPUT|SELECT|BUTTON|^A\\b|TEXTAREA";
    if ($elem$$57_extraTags$$) {
      for (var $newTag$$, $i$$692$$ = 0;$i$$692$$ < $elem$$57_extraTags$$.length;$i$$692$$++) {
        $newTag$$ = $elem$$57_extraTags$$[$i$$692$$].toUpperCase(), $expr$$6_inputRegExp$$4_pattern$$1$$ = $expr$$6_inputRegExp$$4_pattern$$1$$ + "|" + $newTag$$;
      }
    }
    $expr$$6_inputRegExp$$4_pattern$$1$$ = new RegExp($expr$$6_inputRegExp$$4_pattern$$1$$);
    for ($i$$692$$ = 0;$i$$692$$ < $domDoc$$12_nodeCount$$6$$;$i$$692$$++) {
      $elem$$57_extraTags$$ = $node$$145_nodes$$33$$[$i$$692$$], $elem$$57_extraTags$$.tagName.match($expr$$6_inputRegExp$$4_pattern$$1$$) && ($getAll$$ || !$elem$$57_extraTags$$.disabled && -1 != $elem$$57_extraTags$$.tabIndex) && ("A" != $elem$$57_extraTags$$.nodeName || $elem$$57_extraTags$$.href) && $inputElems$$1$$.push($elem$$57_extraTags$$);
    }
  }
  return $inputElems$$1$$;
};
$goog$exportSymbol$$("AdfDomUtils.getInputElementsInNode", $AdfDomUtils$$.$getInputElementsInNode$);
$AdfDomUtils$$.$disableTabStop$ = function $$AdfDomUtils$$$$disableTabStop$$($domElement$$589$$, $disable$$3$$) {
  for (var $elems$$6$$ = $AdfDomUtils$$.$getInputElementsInNode$($domElement$$589$$, !0, ["ul"]), $i$$693$$ = 0;$i$$693$$ < $elems$$6$$.length;$i$$693$$++) {
    var $elem$$58$$ = $elems$$6$$[$i$$693$$];
    $disable$$3$$ ? (void 0 === $elem$$58$$.$_afrTabIndex$ && void 0 !== $elem$$58$$.tabIndex && -1 !== $elem$$58$$.tabIndex && ($elem$$58$$.$_afrTabIndex$ = $elem$$58$$.tabIndex, $elem$$58$$.tabIndex = -1), void 0 === $elem$$58$$.$_afrOverflow$ && "UL" == $elem$$58$$.tagName && $AdfAgent$$.$AGENT$.$getPlatform$() == $AdfAgent$$.$GECKO_PLATFORM$ && ($elem$$58$$.$_afrOverflow$ = $elem$$58$$.style.overflow, $elem$$58$$.style.overflow = "hidden")) : (void 0 !== $elem$$58$$.$_afrTabIndex$ && ($elem$$58$$.tabIndex = 
    $elem$$58$$.$_afrTabIndex$, delete $elem$$58$$.$_afrTabIndex$), void 0 !== $elem$$58$$.$_afrOverflow$ && ($elem$$58$$.style.overflow = $elem$$58$$.$_afrOverflow$, delete $elem$$58$$.$_afrOverflow$));
  }
};
$goog$exportSymbol$$("AdfDomUtils.disableTabStop", $AdfDomUtils$$.$disableTabStop$);
$AdfDomUtils$$.$getNextElement$ = function $$AdfDomUtils$$$$getNextElement$$($currentElement$$7_el$$16$$) {
  if ($currentElement$$7_el$$16$$) {
    for ($currentElement$$7_el$$16$$ = $currentElement$$7_el$$16$$.nextSibling;$currentElement$$7_el$$16$$;) {
      if (1 == $currentElement$$7_el$$16$$.nodeType) {
        return $currentElement$$7_el$$16$$;
      }
      $currentElement$$7_el$$16$$ = $currentElement$$7_el$$16$$.nextSibling;
    }
  }
};
$goog$exportSymbol$$("AdfDomUtils.getNextElement", $AdfDomUtils$$.$getNextElement$);
$AdfDomUtils$$.$getPreviousElement$ = function $$AdfDomUtils$$$$getPreviousElement$$($currentElement$$8_el$$17$$) {
  if ($currentElement$$8_el$$17$$) {
    for ($currentElement$$8_el$$17$$ = $currentElement$$8_el$$17$$.previousSibling;$currentElement$$8_el$$17$$;) {
      if (1 == $currentElement$$8_el$$17$$.nodeType) {
        return $currentElement$$8_el$$17$$;
      }
      $currentElement$$8_el$$17$$ = $currentElement$$8_el$$17$$.previousSibling;
    }
  }
};
$goog$exportSymbol$$("AdfDomUtils.getPreviousElement", $AdfDomUtils$$.$getPreviousElement$);
$AdfDomUtils$$.$getFirstChildNodeByType$ = function $$AdfDomUtils$$$$getFirstChildNodeByType$$($parentElement$$26$$, $type$$197$$) {
  var $childNodes$$37$$ = $parentElement$$26$$.childNodes;
  if ($childNodes$$37$$) {
    for (var $length$$93$$ = $childNodes$$37$$.length, $i$$694$$ = 0;$i$$694$$ < $length$$93$$;$i$$694$$++) {
      var $child$$64$$ = $childNodes$$37$$[$i$$694$$];
      if ($child$$64$$.nodeType == $type$$197$$) {
        return $child$$64$$;
      }
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getFirstChildNodeByType", $AdfDomUtils$$.$getFirstChildNodeByType$);
$AdfDomUtils$$.$getRelativePosition$ = function $$AdfDomUtils$$$$getRelativePosition$$($elem$$59$$) {
  var $currLeft$$1$$ = $elem$$59$$.offsetLeft, $currTop$$1$$ = $elem$$59$$.offsetTop, $agent$$764$$ = $AdfAgent$$.$AGENT$;
  for ($elem$$59$$ = $elem$$59$$.offsetParent;$elem$$59$$;) {
    var $style$$42$$ = $agent$$764$$.getComputedStyle($elem$$59$$);
    if ("static" != $style$$42$$.position && ($agent$$764$$.$getPlatform$() != $AdfAgent$$.$GECKO_PLATFORM$ || "TD" != $elem$$59$$.tagName || "relative" != $style$$42$$.position)) {
      break;
    }
    $currLeft$$1$$ += $elem$$59$$.offsetLeft;
    $currTop$$1$$ += $elem$$59$$.offsetTop;
    $elem$$59$$ = $elem$$59$$.offsetParent;
  }
  return {x:$currLeft$$1$$, y:$currTop$$1$$};
};
$goog$exportSymbol$$("AdfDomUtils.getRelativePosition", $AdfDomUtils$$.$getRelativePosition$);
$AdfDomUtils$$.$getElementPosition$ = function $$AdfDomUtils$$$$getElementPosition$$($currentElement$$9_type$$198$$) {
  var $pos$$41$$ = -1;
  if ($currentElement$$9_type$$198$$) {
    var $el$$18$$ = $currentElement$$9_type$$198$$;
    for ($currentElement$$9_type$$198$$ = $currentElement$$9_type$$198$$.nodeType;$el$$18$$;) {
      $el$$18$$.nodeType == $currentElement$$9_type$$198$$ && $pos$$41$$++, $el$$18$$ = $el$$18$$.previousSibling;
    }
  }
  return $pos$$41$$;
};
$goog$exportSymbol$$("AdfDomUtils.getElementPosition", $AdfDomUtils$$.$getElementPosition$);
$AdfDomUtils$$.$getChildElementByPosition$ = function $$AdfDomUtils$$$$getChildElementByPosition$$($parentElement$$27$$, $type$$199$$, $position$$22$$) {
  var $el$$19$$ = null;
  if ($parentElement$$27$$) {
    for (var $idx$$1$$ = -1, $el$$19$$ = $parentElement$$27$$.firstChild;$el$$19$$ && $idx$$1$$ < $position$$22$$;) {
      $el$$19$$.nodeType == $type$$199$$ && $idx$$1$$++, $idx$$1$$ != $position$$22$$ && ($el$$19$$ = $el$$19$$.nextSibling);
    }
  }
  return $el$$19$$;
};
$goog$exportSymbol$$("AdfDomUtils.getChildElementByPosition", $AdfDomUtils$$.$getChildElementByPosition$);
$AdfDomUtils$$.$getElementDepth$ = function $$AdfDomUtils$$$$getElementDepth$$($element$$335$$) {
  $AdfAssert$$.$assertDomElement$($element$$335$$);
  var $depth$$11$$ = -1;
  do {
    $depth$$11$$++, $element$$335$$ = $element$$335$$.parentNode;
  } while ($element$$335$$);
  return $depth$$11$$;
};
$goog$exportSymbol$$("AdfDomUtils.getElementDepth", $AdfDomUtils$$.$getElementDepth$);
$AdfDomUtils$$.$getElementAtPoint$ = function $$AdfDomUtils$$$$getElementAtPoint$$($currChild$$13_element$$336$$, $pageX$$62$$, $pageY$$62$$, $closestMatch$$, $ignoreList$$1$$) {
  var $agent$$765$$ = $AdfAgent$$.$AGENT$, $computedStyle$$21_newMatch_zeroOffsetHeight$$ = 0 == $currChild$$13_element$$336$$.offsetHeight;
  if (!($ignoreList$$1$$ && $ignoreList$$1$$[$currChild$$13_element$$336$$.localName] || !$computedStyle$$21_newMatch_zeroOffsetHeight$$ && !$agent$$765$$.$pointInElementBounds$($currChild$$13_element$$336$$, $pageX$$62$$, $pageY$$62$$))) {
    for ($computedStyle$$21_newMatch_zeroOffsetHeight$$ || ($closestMatch$$ = $currChild$$13_element$$336$$), $currChild$$13_element$$336$$ = $currChild$$13_element$$336$$.firstChild;$currChild$$13_element$$336$$;) {
      if (1 == $currChild$$13_element$$336$$.nodeType && ($computedStyle$$21_newMatch_zeroOffsetHeight$$ = $agent$$765$$.getComputedStyle($currChild$$13_element$$336$$), !$computedStyle$$21_newMatch_zeroOffsetHeight$$ || "hidden" != $computedStyle$$21_newMatch_zeroOffsetHeight$$.visibility && "none" != $computedStyle$$21_newMatch_zeroOffsetHeight$$.display) && ($computedStyle$$21_newMatch_zeroOffsetHeight$$ = $AdfDomUtils$$.$getElementAtPoint$($currChild$$13_element$$336$$, $pageX$$62$$, $pageY$$62$$, 
      $closestMatch$$, $ignoreList$$1$$), $computedStyle$$21_newMatch_zeroOffsetHeight$$ != $closestMatch$$)) {
        return $computedStyle$$21_newMatch_zeroOffsetHeight$$;
      }
      $currChild$$13_element$$336$$ = $currChild$$13_element$$336$$.nextSibling;
    }
  }
  return $closestMatch$$;
};
$goog$exportSymbol$$("AdfDomUtils.getElementAtPoint", $AdfDomUtils$$.$getElementAtPoint$);
$AdfDomUtils$$.$canScroll$ = function $$AdfDomUtils$$$$canScroll$$($domNode$$109$$, $viewPortWidth$$, $viewPortHeight$$1$$) {
  return $domNode$$109$$.scrollWidth != $viewPortWidth$$ || $domNode$$109$$.scrollHeight != $viewPortHeight$$1$$;
};
$goog$exportSymbol$$("AdfDomUtils.canScroll", $AdfDomUtils$$.$canScroll$);
$AdfDomUtils$$.$getAutoScrollDeltas$ = function $$AdfDomUtils$$$$getAutoScrollDeltas$$($target$$225$$, $clientX$$8_viewPortX$$, $clientY$$7_viewPortY$$) {
  var $clientWidth$$3$$ = $target$$225$$.clientWidth, $clientHeight$$4$$ = $target$$225$$.clientHeight, $deltaX$$41$$ = 0, $deltaY$$46$$ = 0, $scrollTop$$48$$ = $target$$225$$.scrollTop, $scrollLeft$$41$$ = $target$$225$$.scrollLeft;
  $clientX$$8_viewPortX$$ -= $scrollLeft$$41$$;
  $clientY$$7_viewPortY$$ -= $scrollTop$$48$$;
  $scrollLeft$$41$$ && 5 > $clientX$$8_viewPortX$$ ? $deltaX$$41$$ = -Math.min($scrollLeft$$41$$, 10) : 5 > $clientWidth$$3$$ - $clientX$$8_viewPortX$$ && ($deltaX$$41$$ = Math.min($target$$225$$.scrollWidth - $clientWidth$$3$$, 10));
  $scrollTop$$48$$ && 5 > $clientY$$7_viewPortY$$ ? $deltaY$$46$$ = -Math.min($scrollTop$$48$$, 10) : 5 > $clientHeight$$4$$ - $clientY$$7_viewPortY$$ && ($deltaY$$46$$ = Math.min($target$$225$$.scrollHeight - $clientHeight$$4$$, 10));
  return $deltaX$$41$$ || $deltaY$$46$$ ? {x:$deltaX$$41$$, y:$deltaY$$46$$} : null;
};
$goog$exportSymbol$$("AdfDomUtils.getAutoScrollDeltas", $AdfDomUtils$$.$getAutoScrollDeltas$);
$AdfDomUtils$$.$removeAllNodes$ = function $$AdfDomUtils$$$$removeAllNodes$$($element$$337$$) {
  for (var $oldNodes$$1$$ = $element$$337$$.childNodes, $i$$695$$ = $oldNodes$$1$$.length - 1;0 <= $i$$695$$;$i$$695$$--) {
    $element$$337$$.removeChild($oldNodes$$1$$[$i$$695$$]);
  }
};
$goog$exportSymbol$$("AdfDomUtils.removeAllNodes", $AdfDomUtils$$.$removeAllNodes$);
$AdfDomUtils$$.$scrollRightBy$ = function $$AdfDomUtils$$$$scrollRightBy$$($domElement$$590$$, $deltaX$$42$$) {
  $AdfDomUtils$$.setScrollLeft($domElement$$590$$, $domElement$$590$$.scrollLeft + $deltaX$$42$$);
};
$goog$exportSymbol$$("AdfDomUtils.scrollRightBy", $AdfDomUtils$$.$scrollRightBy$);
$AdfDomUtils$$.setScrollLeft = function $$AdfDomUtils$$$setScrollLeft$($domElement$$591$$, $newScrollLeft$$2$$) {
  $newScrollLeft$$2$$ = Math.max($newScrollLeft$$2$$, 0);
  $domElement$$591$$.scrollLeft = Math.min($newScrollLeft$$2$$, $domElement$$591$$.scrollWidth - $domElement$$591$$.clientWidth);
};
$goog$exportSymbol$$("AdfDomUtils.setScrollLeft", $AdfDomUtils$$.setScrollLeft);
$AdfDomUtils$$.$scrollDownBy$ = function $$AdfDomUtils$$$$scrollDownBy$$($domElement$$592$$, $deltaY$$47$$) {
  $AdfDomUtils$$.setScrollTop($domElement$$592$$, $domElement$$592$$.scrollTop + $deltaY$$47$$);
};
$goog$exportSymbol$$("AdfDomUtils.scrollDownBy", $AdfDomUtils$$.$scrollDownBy$);
$AdfDomUtils$$.setScrollTop = function $$AdfDomUtils$$$setScrollTop$($domElement$$593$$, $newScrollTop$$5$$) {
  $newScrollTop$$5$$ = Math.max($newScrollTop$$5$$, 0);
  $domElement$$593$$.scrollTop = Math.min($newScrollTop$$5$$, $domElement$$593$$.scrollHeight - $domElement$$593$$.clientHeight);
};
$goog$exportSymbol$$("AdfDomUtils.setScrollTop", $AdfDomUtils$$.setScrollTop);
$AdfDomUtils$$.$scrollChildIntoViewY$ = function $$AdfDomUtils$$$$scrollChildIntoViewY$$($childElement$$25_scrollParent$$) {
  var $offsetTop$$2$$ = $childElement$$25_scrollParent$$.offsetTop, $offsetHeight$$16$$ = $childElement$$25_scrollParent$$.offsetHeight, $offsetParent$$1$$ = $childElement$$25_scrollParent$$.offsetParent;
  for ($childElement$$25_scrollParent$$ = $childElement$$25_scrollParent$$.parentNode;$childElement$$25_scrollParent$$ && $childElement$$25_scrollParent$$.scrollHeight <= $childElement$$25_scrollParent$$.offsetHeight;) {
    $childElement$$25_scrollParent$$.offsetParent != $offsetParent$$1$$ && ($offsetTop$$2$$ += $childElement$$25_scrollParent$$.offsetTop, $offsetParent$$1$$ = $childElement$$25_scrollParent$$.offsetParent), $childElement$$25_scrollParent$$ = $childElement$$25_scrollParent$$.parentNode;
  }
  null != $childElement$$25_scrollParent$$ && ($offsetTop$$2$$ < $childElement$$25_scrollParent$$.scrollTop ? $childElement$$25_scrollParent$$.scrollTop = $offsetTop$$2$$ : $offsetTop$$2$$ + $offsetHeight$$16$$ > $childElement$$25_scrollParent$$.scrollTop + $childElement$$25_scrollParent$$.clientHeight && ($childElement$$25_scrollParent$$.scrollTop = $offsetTop$$2$$ + $offsetHeight$$16$$ - $childElement$$25_scrollParent$$.clientHeight));
};
$goog$exportSymbol$$("AdfDomUtils.scrollChildIntoViewY", $AdfDomUtils$$.$scrollChildIntoViewY$);
$AdfDomUtils$$.$getNodeInfo$ = function $$AdfDomUtils$$$$getNodeInfo$$($domNode$$110$$) {
  var $nodeInfo$$ = "";
  $domNode$$110$$ && ($nodeInfo$$ += $domNode$$110$$.nodeName, $domNode$$110$$.id && ($nodeInfo$$ += " id\x3d" + $domNode$$110$$.id), $domNode$$110$$.$_afrpeerid$ && ($nodeInfo$$ += " peer id\x3d" + $domNode$$110$$.$_afrpeerid$), $domNode$$110$$.className && ($nodeInfo$$ += " class\x3d" + $domNode$$110$$.className));
  return $nodeInfo$$;
};
$goog$exportSymbol$$("AdfDomUtils.getNodeInfo", $AdfDomUtils$$.$getNodeInfo$);
$AdfDomUtils$$.$suppressActionLinkBrowserContextMenu$ = function $$AdfDomUtils$$$$suppressActionLinkBrowserContextMenu$$($componentContextMenuEvent_root$$28$$) {
  var $agent$$766$$ = $AdfAgent$$.$AGENT$, $nativeEvent$$69$$ = $componentContextMenuEvent_root$$28$$.$getNativeEvent$(), $eventTarget$$100_linkNode$$ = $AdfDomUtils$$.$getElement$($agent$$766$$.$getEventTarget$($nativeEvent$$69$$)), $href$$16$$ = $eventTarget$$100_linkNode$$.getAttribute("href", 2);
  if (null == $href$$16$$ || "" == $href$$16$$) {
    $componentContextMenuEvent_root$$28$$ = $componentContextMenuEvent_root$$28$$.getSource().$getPeer$().$getDomElement$().parentNode, $eventTarget$$100_linkNode$$ = $AdfDomUtils$$.$getParentWithAttr$($componentContextMenuEvent_root$$28$$, $eventTarget$$100_linkNode$$, "href"), null != $eventTarget$$100_linkNode$$ && ($href$$16$$ = $eventTarget$$100_linkNode$$.getAttribute("href", 2));
  }
  null != $href$$16$$ && ("#" != $href$$16$$ && 0 != $href$$16$$.indexOf("javascript:") || $agent$$766$$.preventDefault($nativeEvent$$69$$));
};
$goog$exportSymbol$$("AdfDomUtils.suppressActionLinkBrowserContextMenu", $AdfDomUtils$$.$suppressActionLinkBrowserContextMenu$);
$AdfDomUtils$$.$swapIcon$ = function $$AdfDomUtils$$$$swapIcon$$($originalIcon$$, $iconKey$$4$$) {
  var $clone$$5_rawIcon$$1$$ = $AdfPage$$.$PAGE$.$getLookAndFeel$().$getRawIcon$($iconKey$$4$$), $agent$$767$$ = $AdfAgent$$.$AGENT$;
  null == $clone$$5_rawIcon$$1$$ || $agent$$767$$.$isEqualIcon$($originalIcon$$, $clone$$5_rawIcon$$1$$) || ($agent$$767$$.$getPlatform$() == $AdfAgent$$.$IE_PLATFORM$ && $originalIcon$$.tagName == $clone$$5_rawIcon$$1$$.tagName && "IMG" == $clone$$5_rawIcon$$1$$.tagName ? ($originalIcon$$.src = $clone$$5_rawIcon$$1$$.src, $originalIcon$$.alt = $clone$$5_rawIcon$$1$$.alt, $originalIcon$$.title = $originalIcon$$.title, $originalIcon$$.border = $clone$$5_rawIcon$$1$$.border) : ($clone$$5_rawIcon$$1$$ = 
  $clone$$5_rawIcon$$1$$.cloneNode(!0), $agent$$767$$.$replaceNode$($clone$$5_rawIcon$$1$$, $originalIcon$$)));
};
$goog$exportSymbol$$("AdfDomUtils.swapIcon", $AdfDomUtils$$.$swapIcon$);
$AdfDomUtils$$.$_getCSSClassNameIndex$ = function $$AdfDomUtils$$$$_getCSSClassNameIndex$$($currentClassName$$, $className$$32$$) {
  if ($currentClassName$$ && "string" === typeof $currentClassName$$) {
    if ($className$$32$$ === $currentClassName$$) {
      return 0;
    }
    var $classNameLength$$ = $className$$32$$.length, $currentClassNameLength$$ = $currentClassName$$.length;
    if (!$currentClassName$$.indexOf) {
      return -1;
    }
    var $nameIndex$$ = $currentClassName$$.indexOf($className$$32$$);
    if (0 <= $nameIndex$$) {
      var $hasStart$$ = 0 == $nameIndex$$ || " " == $currentClassName$$.charAt($nameIndex$$ - 1), $endIndex$$17_hasEnd$$ = $nameIndex$$ + $classNameLength$$, $endIndex$$17_hasEnd$$ = $endIndex$$17_hasEnd$$ == $currentClassNameLength$$ || " " == $currentClassName$$.charAt($endIndex$$17_hasEnd$$);
      if ($hasStart$$ && $endIndex$$17_hasEnd$$) {
        return $nameIndex$$;
      }
      var $lastNameIndex$$ = $currentClassName$$.lastIndexOf($className$$32$$);
      if ($lastNameIndex$$ != $nameIndex$$) {
        return $hasStart$$ = $currentClassName$$.charAt($lastNameIndex$$ - 1), $endIndex$$17_hasEnd$$ = $lastNameIndex$$ + $classNameLength$$, $endIndex$$17_hasEnd$$ = $endIndex$$17_hasEnd$$ == $currentClassNameLength$$ || " " == $currentClassName$$.charAt($endIndex$$17_hasEnd$$), $hasStart$$ && $endIndex$$17_hasEnd$$ ? $lastNameIndex$$ : $currentClassName$$.indexOf(" " + $className$$32$$ + " ");
      }
    }
  }
  return -1;
};
$AdfDomUtils$$.$addCSSClassName$ = function $$AdfDomUtils$$$$addCSSClassName$$($domElement$$594$$, $className$$33$$) {
  $AdfAssert$$.$assertDomElement$($domElement$$594$$);
  var $added$$5$$ = !1;
  if (null != $className$$33$$) {
    $AdfAssert$$.$assertString$($className$$33$$);
    var $currentClassName$$1$$ = $domElement$$594$$.className;
    -1 == $AdfDomUtils$$.$_getCSSClassNameIndex$($currentClassName$$1$$, $className$$33$$) && ($domElement$$594$$.className = $currentClassName$$1$$ ? $className$$33$$ + " " + $currentClassName$$1$$ : $className$$33$$, $added$$5$$ = !0);
  }
  return $added$$5$$;
};
$goog$exportSymbol$$("AdfDomUtils.addCSSClassName", $AdfDomUtils$$.$addCSSClassName$);
$AdfDomUtils$$.$removeCSSClassName$ = function $$AdfDomUtils$$$$removeCSSClassName$$($domElement$$595$$, $className$$34$$) {
  $AdfAssert$$.$assertDomElement$($domElement$$595$$);
  var $classNameEndIndex_removed$$3$$ = !1;
  if (null != $className$$34$$) {
    var $afterString_currentClassName$$2$$ = $domElement$$595$$.className, $beforeString_classNameIndex$$1$$ = $AdfDomUtils$$.$_getCSSClassNameIndex$($afterString_currentClassName$$2$$, $className$$34$$);
    -1 != $beforeString_classNameIndex$$1$$ && ($classNameEndIndex_removed$$3$$ = $beforeString_classNameIndex$$1$$ + $className$$34$$.length, $beforeString_classNameIndex$$1$$ = 0 == $beforeString_classNameIndex$$1$$ ? null : $afterString_currentClassName$$2$$.substring(0, $beforeString_classNameIndex$$1$$), $afterString_currentClassName$$2$$ = $classNameEndIndex_removed$$3$$ == $afterString_currentClassName$$2$$.length ? null : $afterString_currentClassName$$2$$.substring($classNameEndIndex_removed$$3$$ + 
    1), $domElement$$595$$.className = null == $beforeString_classNameIndex$$1$$ ? null == $afterString_currentClassName$$2$$ ? "" : $afterString_currentClassName$$2$$ : null == $afterString_currentClassName$$2$$ ? $beforeString_classNameIndex$$1$$ : $beforeString_classNameIndex$$1$$ + $afterString_currentClassName$$2$$, $classNameEndIndex_removed$$3$$ = !0);
  }
  return $classNameEndIndex_removed$$3$$;
};
$goog$exportSymbol$$("AdfDomUtils.removeCSSClassName", $AdfDomUtils$$.$removeCSSClassName$);
$AdfDomUtils$$.$addOrRemoveCSSClassName$ = function $$AdfDomUtils$$$$addOrRemoveCSSClassName$$($add$$1$$, $domElement$$596$$, $className$$35$$) {
  return ($add$$1$$ ? $AdfDomUtils$$.$addCSSClassName$ : $AdfDomUtils$$.$removeCSSClassName$)($domElement$$596$$, $className$$35$$);
};
$goog$exportSymbol$$("AdfDomUtils.addOrRemoveCSSClassName", $AdfDomUtils$$.$addOrRemoveCSSClassName$);
$AdfDomUtils$$.$containsCSSClassName$ = function $$AdfDomUtils$$$$containsCSSClassName$$($domElement$$597$$, $className$$36$$) {
  return null != $className$$36$$ ? -1 != $AdfDomUtils$$.$_getCSSClassNameIndex$($domElement$$597$$.className, $className$$36$$) : !1;
};
$goog$exportSymbol$$("AdfDomUtils.containsCSSClassName", $AdfDomUtils$$.$containsCSSClassName$);
$AdfDomUtils$$.$addInlineStyle$ = function $$AdfDomUtils$$$$addInlineStyle$$($element$$338$$, $newStyle$$1$$, $takesPrecedence$$) {
  if (null != $newStyle$$1$$) {
    var $existingStyle$$ = $element$$338$$.style.cssText;
    $element$$338$$.style.cssText = null == $existingStyle$$ || "" == $existingStyle$$ ? $newStyle$$1$$ : 1 == $takesPrecedence$$ ? $existingStyle$$ + ";" + $newStyle$$1$$ : $newStyle$$1$$ + ";" + $existingStyle$$;
  }
};
$goog$exportSymbol$$("AdfDomUtils.addInlineStyle", $AdfDomUtils$$.$addInlineStyle$);
$AdfDomUtils$$.$fillEmptyCell$ = function $$AdfDomUtils$$$$fillEmptyCell$$($cell$$47$$) {
  $AdfAssert$$.$assertDomElement$($cell$$47$$, "TD");
  null == $cell$$47$$.firstChild && $cell$$47$$.appendChild($cell$$47$$.ownerDocument.createElement("div"));
};
$goog$exportSymbol$$("AdfDomUtils.fillEmptyCell", $AdfDomUtils$$.$fillEmptyCell$);
$AdfDomUtils$$.getElementsByClassName = function $$AdfDomUtils$$$getElementsByClassName$($domNode$$111$$, $className$$37$$) {
  null == $domNode$$111$$ && ($domNode$$111$$ = $AdfAgent$$.$AGENT$.$getDomDocument$().documentElement);
  for (var $allElements$$ = $domNode$$111$$.getElementsByTagName("*"), $length$$94$$ = $allElements$$.length, $classElements$$ = [], $element$$339$$, $i$$696$$ = 0;$i$$696$$ < $length$$94$$;$i$$696$$++) {
    $element$$339$$ = $allElements$$[$i$$696$$], $AdfDomUtils$$.$containsCSSClassName$($element$$339$$, $className$$37$$) && $classElements$$.push($element$$339$$);
  }
  return $classElements$$;
};
$goog$exportSymbol$$("AdfDomUtils.getElementsByClassName", $AdfDomUtils$$.getElementsByClassName);
$AdfDomUtils$$.$setAccessibleState$ = function $$AdfDomUtils$$$$setAccessibleState$$($component$$2319$$, $state$$99$$) {
  var $agent$$768$$ = $AdfAgent$$.$AGENT$, $stateElement_subId$$44$$ = $AdfRichUIPeer$$.$CreateSubId$($component$$2319$$.$getClientId$(), "state"), $stateElement_subId$$44$$ = $agent$$768$$.getElementById($stateElement_subId$$44$$);
  $AdfAssert$$.$assertDomNode$($stateElement_subId$$44$$);
  null != $state$$99$$ ? $agent$$768$$.$setTextContent$($stateElement_subId$$44$$, " " + $state$$99$$ + " ") : $agent$$768$$.$setTextContent$($stateElement_subId$$44$$, "");
};
$goog$exportSymbol$$("AdfDomUtils.setAccessibleState", $AdfDomUtils$$.$setAccessibleState$);
$AdfDomUtils$$.$getFirstElementMatch$ = function $$AdfDomUtils$$$$getFirstElementMatch$$($element$$340_elements$$27$$, $isExclusive_length$$95$$, $matchFunc$$1$$, $context$$55$$) {
  $AdfAssert$$.$assertFunction$($matchFunc$$1$$);
  $AdfAssert$$.$assertDomElement$($element$$340_elements$$27$$);
  if (!$isExclusive_length$$95$$ && $matchFunc$$1$$($element$$340_elements$$27$$, $context$$55$$)) {
    return $element$$340_elements$$27$$;
  }
  if ($element$$340_elements$$27$$.getElementsByTagName) {
    $element$$340_elements$$27$$ = $element$$340_elements$$27$$.getElementsByTagName("*");
    $isExclusive_length$$95$$ = $element$$340_elements$$27$$.length;
    for (var $i$$697$$ = 0;$i$$697$$ < $isExclusive_length$$95$$;$i$$697$$++) {
      var $currElement$$23$$ = $element$$340_elements$$27$$[$i$$697$$];
      if ($matchFunc$$1$$($currElement$$23$$, $context$$55$$)) {
        return $currElement$$23$$;
      }
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getFirstElementMatch", $AdfDomUtils$$.$getFirstElementMatch$);
$AdfDomUtils$$.$getNextElementMatch$ = function $$AdfDomUtils$$$$getNextElementMatch$$($element$$341$$, $contextElement$$, $isExclusive$$1$$, $matchFunc$$2$$, $context$$56$$) {
  $AdfAssert$$.$assertFunction$($matchFunc$$2$$);
  $AdfAssert$$.$assertDomElement$($element$$341$$);
  $AdfAssert$$.$assertDomElementOrNull$($contextElement$$);
  var $matchElement$$2$$ = null;
  if (!$isExclusive$$1$$ && ($matchElement$$2$$ = $AdfDomUtils$$.$getFirstElementMatch$($element$$341$$, !0, $matchFunc$$2$$, $context$$56$$), null != $matchElement$$2$$)) {
    return $matchElement$$2$$;
  }
  for (;$element$$341$$ && $element$$341$$ != $contextElement$$;) {
    if ($element$$341$$.nextSibling) {
      if ($element$$341$$ = $element$$341$$.nextSibling, 1 == $element$$341$$.nodeType && ($matchElement$$2$$ = $AdfDomUtils$$.$getFirstElementMatch$($element$$341$$, !1, $matchFunc$$2$$, $context$$56$$), null != $matchElement$$2$$)) {
        return $matchElement$$2$$;
      }
    } else {
      $element$$341$$ = $element$$341$$.parentNode;
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getNextElementMatch", $AdfDomUtils$$.$getNextElementMatch$);
$AdfDomUtils$$.$getLastElementMatch$ = function $$AdfDomUtils$$$$getLastElementMatch$$($element$$342$$, $isExclusive$$2$$, $matchFunc$$3$$, $context$$57$$) {
  $AdfAssert$$.$assertFunction$($matchFunc$$3$$);
  $AdfAssert$$.$assertDomElement$($element$$342$$);
  if ($element$$342$$.getElementsByTagName) {
    for (var $elements$$28$$ = $element$$342$$.getElementsByTagName("*"), $i$$698$$ = $elements$$28$$.length - 1;0 <= $i$$698$$;$i$$698$$--) {
      var $currElement$$24$$ = $elements$$28$$[$i$$698$$];
      if ($matchFunc$$3$$($currElement$$24$$, $context$$57$$)) {
        return $currElement$$24$$;
      }
    }
  }
  return !$isExclusive$$2$$ && $matchFunc$$3$$($element$$342$$, $context$$57$$) ? $element$$342$$ : null;
};
$goog$exportSymbol$$("AdfDomUtils.getLastElementMatch", $AdfDomUtils$$.$getLastElementMatch$);
$AdfDomUtils$$.$getPreviousElementMatch$ = function $$AdfDomUtils$$$$getPreviousElementMatch$$($element$$343_parentElement$$28$$, $contextElement$$1$$, $matchFunc$$4$$, $context$$58$$) {
  $AdfAssert$$.$assertFunction$($matchFunc$$4$$);
  $AdfAssert$$.$assertDomElement$($element$$343_parentElement$$28$$);
  for ($AdfAssert$$.$assertDomElementOrNull$($contextElement$$1$$);$element$$343_parentElement$$28$$ && $element$$343_parentElement$$28$$ != $contextElement$$1$$;) {
    for (var $previousElement$$ = $element$$343_parentElement$$28$$.previousSibling;$previousElement$$ && 1 != $previousElement$$.nodeType;) {
      $previousElement$$ = $previousElement$$.previousSibling;
    }
    if ($previousElement$$) {
      matchElement = $AdfDomUtils$$.$getLastElementMatch$($previousElement$$, !1, $matchFunc$$4$$, $context$$58$$);
      if (null != matchElement) {
        return matchElement;
      }
      $element$$343_parentElement$$28$$ = $previousElement$$;
    } else {
      if ($element$$343_parentElement$$28$$ = $element$$343_parentElement$$28$$.parentNode, $element$$343_parentElement$$28$$ != $contextElement$$1$$ && $matchFunc$$4$$($element$$343_parentElement$$28$$, $context$$58$$)) {
        return $element$$343_parentElement$$28$$;
      }
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getPreviousElementMatch", $AdfDomUtils$$.$getPreviousElementMatch$);
$AdfDomUtils$$.$getFirstFilteredElement$ = function $$AdfDomUtils$$$$getFirstFilteredElement$$($element$$344$$, $isExclusive$$3$$, $filterFunc$$5$$, $context$$59$$) {
  $AdfAssert$$.$assertFunction$($filterFunc$$5$$);
  $AdfAssert$$.$assertDomElement$($element$$344$$);
  var $filterResult$$1$$ = $filterFunc$$5$$($element$$344$$, $context$$59$$);
  return $isExclusive$$3$$ || $filterResult$$1$$ != $AdfDomUtils$$.FILTER_ACCEPT ? $filterResult$$1$$ == $AdfDomUtils$$.FILTER_REJECT ? null : $AdfDomUtils$$.$depthFirstFilter$($element$$344$$, $element$$344$$, $filterFunc$$5$$, $context$$59$$) : $element$$344$$;
};
$goog$exportSymbol$$("AdfDomUtils.getFirstFilteredElement", $AdfDomUtils$$.$getFirstFilteredElement$);
$AdfDomUtils$$.$depthFirstFilter$ = function $$AdfDomUtils$$$$depthFirstFilter$$($element$$345_nextSearchElement$$, $rootElement$$166$$, $filterFunc$$6$$, $context$$60$$) {
  if (null == $element$$345_nextSearchElement$$) {
    return null;
  }
  var $filterResult$$2$$ = $filterFunc$$6$$($element$$345_nextSearchElement$$, $context$$60$$);
  $element$$345_nextSearchElement$$ == $rootElement$$166$$ && ($filterResult$$2$$ = $AdfDomUtils$$.FILTER_SKIP);
  if ($filterResult$$2$$ == $AdfDomUtils$$.FILTER_ACCEPT) {
    return $element$$345_nextSearchElement$$;
  }
  var $retElem$$ = null;
  if ($filterResult$$2$$ != $AdfDomUtils$$.FILTER_REJECT) {
    for ($element$$345_nextSearchElement$$ = $element$$345_nextSearchElement$$.firstChild;$element$$345_nextSearchElement$$ && !$retElem$$;) {
      $retElem$$ = $AdfDomUtils$$.$depthFirstFilter$($element$$345_nextSearchElement$$, $rootElement$$166$$, $filterFunc$$6$$, $context$$60$$), $element$$345_nextSearchElement$$ = $element$$345_nextSearchElement$$.nextSibling;
    }
  }
  return $retElem$$;
};
$goog$exportSymbol$$("AdfDomUtils.depthFirstFilter", $AdfDomUtils$$.$depthFirstFilter$);
$AdfDomUtils$$.$getNextFilteredElement$ = function $$AdfDomUtils$$$$getNextFilteredElement$$($element$$346_parentElement$$29$$, $contextElement$$2$$, $isExclusive$$4$$, $filterFunc$$7$$, $context$$61$$) {
  $AdfAssert$$.$assertFunction$($filterFunc$$7$$);
  $AdfAssert$$.$assertDomElement$($element$$346_parentElement$$29$$);
  $AdfAssert$$.$assertDomElementOrNull$($contextElement$$2$$);
  var $filteredElement$$ = null;
  if (!$isExclusive$$4$$ && ($filteredElement$$ = $AdfDomUtils$$.$getFirstFilteredElement$($element$$346_parentElement$$29$$, !1, $filterFunc$$7$$, $context$$61$$), null != $filteredElement$$)) {
    return $filteredElement$$;
  }
  for (;$element$$346_parentElement$$29$$ && $element$$346_parentElement$$29$$ != $contextElement$$2$$;) {
    if ($element$$346_parentElement$$29$$.nextSibling) {
      if ($element$$346_parentElement$$29$$ = $element$$346_parentElement$$29$$.nextSibling, 1 == $element$$346_parentElement$$29$$.nodeType && ($filteredElement$$ = $AdfDomUtils$$.$getFirstFilteredElement$($element$$346_parentElement$$29$$, !1, $filterFunc$$7$$, $context$$61$$), null != $filteredElement$$)) {
        return $filteredElement$$;
      }
    } else {
      if (($element$$346_parentElement$$29$$ = $element$$346_parentElement$$29$$.parentNode) && $element$$346_parentElement$$29$$ != $contextElement$$2$$ && 1 == $element$$346_parentElement$$29$$.nodeType && $filterFunc$$7$$($element$$346_parentElement$$29$$, $context$$61$$) == $AdfDomUtils$$.FILTER_ACCEPT) {
        return $element$$346_parentElement$$29$$;
      }
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getNextFilteredElement", $AdfDomUtils$$.$getNextFilteredElement$);
$AdfDomUtils$$.$reverseDepthFirstFilter$ = function $$AdfDomUtils$$$$reverseDepthFirstFilter$$($element$$347$$, $rootElement$$167$$, $filterFunc$$8$$, $context$$62$$) {
  if (null == $element$$347$$) {
    return null;
  }
  var $filterResult$$3$$ = $filterFunc$$8$$($element$$347$$, $context$$62$$), $retElem$$1$$ = null;
  $element$$347$$ == $rootElement$$167$$ && ($filterResult$$3$$ = $AdfDomUtils$$.FILTER_SKIP);
  if ($filterResult$$3$$ != $AdfDomUtils$$.FILTER_REJECT) {
    for (var $nextSearchElement$$1$$ = $element$$347$$.lastChild;$nextSearchElement$$1$$ && !$retElem$$1$$;) {
      $retElem$$1$$ = $AdfDomUtils$$.$reverseDepthFirstFilter$($nextSearchElement$$1$$, $rootElement$$167$$, $filterFunc$$8$$, $context$$62$$), $nextSearchElement$$1$$ = $nextSearchElement$$1$$.previousSibling;
    }
  }
  $retElem$$1$$ || $filterResult$$3$$ != $AdfDomUtils$$.FILTER_ACCEPT || ($retElem$$1$$ = $element$$347$$);
  return $retElem$$1$$;
};
$goog$exportSymbol$$("AdfDomUtils.reverseDepthFirstFilter", $AdfDomUtils$$.$reverseDepthFirstFilter$);
$AdfDomUtils$$.$getLastFilteredElement$ = function $$AdfDomUtils$$$$getLastFilteredElement$$($element$$348$$, $isExclusive$$5$$, $filterFunc$$9$$, $context$$63$$) {
  $AdfAssert$$.$assertFunction$($filterFunc$$9$$);
  $AdfAssert$$.$assertDomElement$($element$$348$$);
  var $filteredElement$$1$$ = $AdfDomUtils$$.$reverseDepthFirstFilter$($element$$348$$, $element$$348$$, $filterFunc$$9$$, $context$$63$$);
  return null != $filteredElement$$1$$ ? $filteredElement$$1$$ : $isExclusive$$5$$ || $filterFunc$$9$$($element$$348$$, $context$$63$$) != $AdfDomUtils$$.FILTER_ACCEPT ? null : $element$$348$$;
};
$goog$exportSymbol$$("AdfDomUtils.getLastFilteredElement", $AdfDomUtils$$.$getLastFilteredElement$);
$AdfDomUtils$$.$getPreviousFilteredElement$ = function $$AdfDomUtils$$$$getPreviousFilteredElement$$($element$$349_parentElement$$30$$, $contextElement$$3$$, $filterFunc$$10$$, $context$$64$$) {
  $AdfAssert$$.$assertFunction$($filterFunc$$10$$);
  $AdfAssert$$.$assertDomElement$($element$$349_parentElement$$30$$);
  $AdfAssert$$.$assertDomElementOrNull$($contextElement$$3$$);
  for (var $acceptedElement$$ = null;$element$$349_parentElement$$30$$ && $element$$349_parentElement$$30$$ != $contextElement$$3$$;) {
    if ($element$$349_parentElement$$30$$.previousSibling) {
      if ($element$$349_parentElement$$30$$ = $element$$349_parentElement$$30$$.previousSibling, 1 == $element$$349_parentElement$$30$$.nodeType && ($acceptedElement$$ = $AdfDomUtils$$.$getLastFilteredElement$($element$$349_parentElement$$30$$, !1, $filterFunc$$10$$, $context$$64$$), null != $acceptedElement$$)) {
        return $acceptedElement$$;
      }
    } else {
      if (($element$$349_parentElement$$30$$ = $element$$349_parentElement$$30$$.parentNode) && $element$$349_parentElement$$30$$ != $contextElement$$3$$ && 1 == $element$$349_parentElement$$30$$.nodeType && $filterFunc$$10$$($element$$349_parentElement$$30$$, $context$$64$$) == $AdfDomUtils$$.FILTER_ACCEPT) {
        return $element$$349_parentElement$$30$$;
      }
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getPreviousFilteredElement", $AdfDomUtils$$.$getPreviousFilteredElement$);
$AdfDomUtils$$.$getParentWithAttr$ = function $$AdfDomUtils$$$$getParentWithAttr$$($rootElement$$168$$, $startElement$$1_target$$226$$, $attr$$5$$) {
  for (;$startElement$$1_target$$226$$ && $startElement$$1_target$$226$$ != $rootElement$$168$$;) {
    if (1 == $startElement$$1_target$$226$$.nodeType && $AdfAgent$$.$AGENT$.getAttribute($startElement$$1_target$$226$$, $attr$$5$$)) {
      return $startElement$$1_target$$226$$;
    }
    $startElement$$1_target$$226$$ = $startElement$$1_target$$226$$.parentNode;
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getParentWithAttr", $AdfDomUtils$$.$getParentWithAttr$);
$AdfDomUtils$$.$getFirstChildElementByAttributeValue$ = $AdfDomUtils$$.$getChildElementByAttributeValue$ = function $$AdfDomUtils$$$$getChildElementByAttributeValue$$($childElements$$9_domElement$$598$$, $attrName$$13$$, $attrValue$$21$$, $length$$96_tagName$$15$$) {
  $AdfAssert$$.$assertNonEmptyString$($attrName$$13$$);
  $AdfAssert$$.$assertString$($attrValue$$21$$);
  $AdfAssert$$.$assertDomElement$($childElements$$9_domElement$$598$$);
  $length$$96_tagName$$15$$ || ($length$$96_tagName$$15$$ = "*");
  $childElements$$9_domElement$$598$$ = $childElements$$9_domElement$$598$$.getElementsByTagName($length$$96_tagName$$15$$);
  $length$$96_tagName$$15$$ = $childElements$$9_domElement$$598$$.length;
  for (var $i$$699$$ = 0;$i$$699$$ < $length$$96_tagName$$15$$;$i$$699$$++) {
    if (element = $childElements$$9_domElement$$598$$[$i$$699$$], element.getAttribute($attrName$$13$$) == $attrValue$$21$$) {
      return element;
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getFirstChildElementByAttributeValue", $AdfDomUtils$$.$getFirstChildElementByAttributeValue$);
$AdfDomUtils$$.$getLastChildElementByAttributeValue$ = function $$AdfDomUtils$$$$getLastChildElementByAttributeValue$$($childElements$$10_domElement$$599$$, $attrName$$14$$, $attrValue$$22$$, $i$$700_tagName$$16$$) {
  $AdfAssert$$.$assertNonEmptyString$($attrName$$14$$);
  $AdfAssert$$.$assertString$($attrValue$$22$$);
  $AdfAssert$$.$assertDomElement$($childElements$$10_domElement$$599$$);
  $i$$700_tagName$$16$$ || ($i$$700_tagName$$16$$ = "*");
  $childElements$$10_domElement$$599$$ = $childElements$$10_domElement$$599$$.getElementsByTagName($i$$700_tagName$$16$$);
  for ($i$$700_tagName$$16$$ = $childElements$$10_domElement$$599$$.length - 1;0 <= $i$$700_tagName$$16$$;$i$$700_tagName$$16$$--) {
    if (element = $childElements$$10_domElement$$599$$[$i$$700_tagName$$16$$], element.getAttribute($attrName$$14$$) == $attrValue$$22$$) {
      return element;
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.getLastChildElementByAttributeValue", $AdfDomUtils$$.$getLastChildElementByAttributeValue$);
$AdfDomUtils$$.$getChildElementsByAttributeValue$ = function $$AdfDomUtils$$$$getChildElementsByAttributeValue$$($allChildElements_domElement$$600$$, $attrName$$15$$, $attrValue$$23$$, $length$$98_tagName$$17$$) {
  $AdfAssert$$.$assertNonEmptyString$($attrName$$15$$);
  $AdfAssert$$.$assertNonEmptyString$($attrValue$$23$$);
  $AdfAssert$$.$assertDomElement$($allChildElements_domElement$$600$$);
  $length$$98_tagName$$17$$ || ($length$$98_tagName$$17$$ = "*");
  $allChildElements_domElement$$600$$ = $allChildElements_domElement$$600$$.getElementsByTagName($length$$98_tagName$$17$$);
  $length$$98_tagName$$17$$ = $allChildElements_domElement$$600$$.length;
  for (var $childElements$$11$$ = [], $i$$701$$ = 0;$i$$701$$ < $length$$98_tagName$$17$$;$i$$701$$++) {
    var $element$$350$$ = $allChildElements_domElement$$600$$[$i$$701$$];
    $element$$350$$.getAttribute($attrName$$15$$) == $attrValue$$23$$ && $childElements$$11$$.push($element$$350$$);
  }
  return 0 < $childElements$$11$$.length ? $childElements$$11$$ : null;
};
$goog$exportSymbol$$("AdfDomUtils.getChildElementsByAttributeValue", $AdfDomUtils$$.$getChildElementsByAttributeValue$);
$AdfDomUtils$$.$getChildElementsByMatch$ = function $$AdfDomUtils$$$$getChildElementsByMatch$$($allChildElements$$1_domElement$$601$$, $matchFunction$$, $length$$99_tagName$$18$$, $context$$65$$) {
  $AdfAssert$$.$assertDomElement$($allChildElements$$1_domElement$$601$$);
  $AdfAssert$$.$assertFunction$($matchFunction$$);
  $length$$99_tagName$$18$$ || ($length$$99_tagName$$18$$ = "*");
  $allChildElements$$1_domElement$$601$$ = $allChildElements$$1_domElement$$601$$.getElementsByTagName($length$$99_tagName$$18$$);
  $length$$99_tagName$$18$$ = $allChildElements$$1_domElement$$601$$.length;
  for (var $matchedChildElements$$ = [], $i$$702$$ = 0;$i$$702$$ < $length$$99_tagName$$18$$;$i$$702$$++) {
    var $element$$351$$ = $allChildElements$$1_domElement$$601$$[$i$$702$$];
    $matchFunction$$($element$$351$$, $context$$65$$) && $matchedChildElements$$.push($element$$351$$);
  }
  return 0 < $matchedChildElements$$.length ? $matchedChildElements$$ : null;
};
$goog$exportSymbol$$("AdfDomUtils.getChildElementsByMatch", $AdfDomUtils$$.$getChildElementsByMatch$);
$AdfDomUtils$$.$getChildElementsByMatch$ = function $$AdfDomUtils$$$$getChildElementsByMatch$$($allChildElements$$2_domElement$$602$$, $matchFunction$$1$$, $length$$100_tagName$$19$$, $context$$66$$) {
  $AdfAssert$$.$assertDomElement$($allChildElements$$2_domElement$$602$$);
  $AdfAssert$$.$assertFunction$($matchFunction$$1$$);
  $length$$100_tagName$$19$$ || ($length$$100_tagName$$19$$ = "*");
  $allChildElements$$2_domElement$$602$$ = $allChildElements$$2_domElement$$602$$.getElementsByTagName($length$$100_tagName$$19$$);
  $length$$100_tagName$$19$$ = $allChildElements$$2_domElement$$602$$.length;
  for (var $matchedChildElements$$1$$ = [], $i$$703$$ = 0;$i$$703$$ < $length$$100_tagName$$19$$;$i$$703$$++) {
    var $element$$352$$ = $allChildElements$$2_domElement$$602$$[$i$$703$$];
    $matchFunction$$1$$($element$$352$$, $context$$66$$) && $matchedChildElements$$1$$.push($element$$352$$);
  }
  return 0 < $matchedChildElements$$1$$.length ? $matchedChildElements$$1$$ : null;
};
$goog$exportSymbol$$("AdfDomUtils.getChildElementsByMatch", $AdfDomUtils$$.$getChildElementsByMatch$);
$AdfDomUtils$$.$getChildElementByValueMap$ = function $$AdfDomUtils$$$$getChildElementByValueMap$$($domElement$$603$$, $keyValueArray$$, $tagName$$20$$) {
  $AdfAssert$$.$assertDomElement$($domElement$$603$$);
  $AdfAssert$$.$assertArray$($keyValueArray$$);
  $AdfAssert$$.assert(2 == $keyValueArray$$.length);
  $tagName$$20$$ || ($tagName$$20$$ = "*");
  return $AdfDomUtils$$.$getChildElementByAttributeValue$($domElement$$603$$, $keyValueArray$$[0], $keyValueArray$$[1], $tagName$$20$$);
};
$goog$exportSymbol$$("AdfDomUtils.getChildElementByValueMap", $AdfDomUtils$$.$getChildElementByValueMap$);
$AdfDomUtils$$.$getTabIndex$ = function $$AdfDomUtils$$$$getTabIndex$$($element$$353$$) {
  $AdfAssert$$.$assertDomElement$($element$$353$$);
  var $agent$$769$$ = $AdfAgent$$.$AGENT$, $tabIndexAttr$$ = $element$$353$$.attributes.tabIndex;
  return null != $tabIndexAttr$$ && $agent$$769$$.hasAttribute($element$$353$$, $tabIndexAttr$$) ? $tabIndexAttr$$.value : void 0;
};
$goog$exportSymbol$$("AdfDomUtils.getTabIndex", $AdfDomUtils$$.$getTabIndex$);
$AdfDomUtils$$.$cleanHtml$ = function $$AdfDomUtils$$$$cleanHtml$$($domDocument$$71$$, $value$$270$$) {
  var $offSpan$$ = $domDocument$$71$$.createElement("span");
  ($offSpan$$.innerHTML = $value$$270$$) && 0 <= $value$$270$$.indexOf("\x3c") && $AdfDomUtils$$.$_cleanElementHtml$($offSpan$$);
  return $offSpan$$;
};
$goog$exportSymbol$$("AdfDomUtils.cleanHtml", $AdfDomUtils$$.$cleanHtml$);
$AdfDomUtils$$.$_cleanElementHtml$ = function $$AdfDomUtils$$$$_cleanElementHtml$$($node$$146$$) {
  for (var $agent$$770$$ = $AdfAgent$$.$AGENT$, $children$$72$$ = $node$$146$$.childNodes, $count$$38$$ = $children$$72$$.length - 1;0 <= $count$$38$$;) {
    var $child$$65$$ = $children$$72$$.item($count$$38$$);
    if (1 == $child$$65$$.nodeType) {
      if ($AdfDomUtils$$.$_LEGAL_ELEMENTS$[$child$$65$$.nodeName]) {
        for (var $attrs$$58$$ = $child$$65$$.attributes, $i$$704$$ = $attrs$$58$$.length - 1;0 <= $i$$704$$;$i$$704$$--) {
          var $attr$$6$$ = $attrs$$58$$[$i$$704$$];
          $agent$$770$$.hasAttribute($child$$65$$, $attr$$6$$) && ($AdfDomUtils$$.$_LEGAL_ATTRIBUTES$[$attr$$6$$.name] || $child$$65$$.removeAttribute($attr$$6$$.nodeName));
        }
        $AdfDomUtils$$.$_cleanElementHtml$($child$$65$$);
      } else {
        $node$$146$$.removeChild($child$$65$$);
      }
    }
    $count$$38$$--;
  }
};
$AdfDomUtils$$.$findAccessKeyDom$ = function $$AdfDomUtils$$$$findAccessKeyDom$$($domElement$$604$$, $accessKeyValue$$1$$) {
  if (null == $accessKeyValue$$1$$) {
    return null;
  }
  for (var $children$$73$$ = $domElement$$604$$.childNodes, $i$$705$$ = 0;$i$$705$$ < $children$$73$$.length;++$i$$705$$) {
    if ($AdfAgent$$.$AGENT$.$getTextContent$($children$$73$$[$i$$705$$]) == $accessKeyValue$$1$$) {
      return $children$$73$$[$i$$705$$];
    }
  }
  return null;
};
$goog$exportSymbol$$("AdfDomUtils.findAccessKeyDom", $AdfDomUtils$$.$findAccessKeyDom$);
$AdfDomUtils$$.$handleTextChangeWithAccessKey$ = function $$AdfDomUtils$$$$handleTextChangeWithAccessKey$$($component$$2320_index$$217$$, $domElement$$605$$, $newValue$$183$$) {
  if (null == $domElement$$605$$) {
    return !1;
  }
  var $accessKeyValue$$2$$ = $component$$2320_index$$217$$.getPropertyValue("accessKey"), $accessKeySpan$$ = $AdfDomUtils$$.$findAccessKeyDom$($domElement$$605$$, $accessKeyValue$$2$$);
  if (null != $accessKeyValue$$2$$) {
    var $doc$$67$$ = $component$$2320_index$$217$$.$getPeer$().$getDomDocument$();
    return null != $accessKeySpan$$ ? ($component$$2320_index$$217$$ = $newValue$$183$$.indexOf($accessKeyValue$$2$$), -1 == $component$$2320_index$$217$$ ? ($AdfDomUtils$$.$_removeAccessKeyElement$($domElement$$605$$, $accessKeySpan$$), $AdfDomUtils$$.$_setTextContent$($domElement$$605$$, $newValue$$183$$)) : ($AdfDomUtils$$.$_removeSiblings$($accessKeySpan$$), 0 < $component$$2320_index$$217$$ && $domElement$$605$$.insertBefore($doc$$67$$.createTextNode($newValue$$183$$.substring(0, $component$$2320_index$$217$$)), 
    $accessKeySpan$$), $AdfDomUtils$$.$_setTextContent$($accessKeySpan$$, $accessKeyValue$$2$$), $component$$2320_index$$217$$ + 1 < $newValue$$183$$.length && $domElement$$605$$.appendChild($doc$$67$$.createTextNode($newValue$$183$$.substr($component$$2320_index$$217$$ + 1)))), !0) : $AdfDomUtils$$.$_setTextAndAccessKeySpan$($component$$2320_index$$217$$, $domElement$$605$$, $accessKeyValue$$2$$, $accessKeySpan$$, $newValue$$183$$);
  }
  null != $accessKeySpan$$ && $AdfDomUtils$$.$_removeAccessKeyElement$($accessKeySpan$$);
  $AdfDomUtils$$.$_setTextContent$($domElement$$605$$, $newValue$$183$$);
  return !0;
};
$goog$exportSymbol$$("AdfDomUtils.handleTextChangeWithAccessKey", $AdfDomUtils$$.$handleTextChangeWithAccessKey$);
$AdfDomUtils$$.$launchHelpWindow$ = function $$AdfDomUtils$$$$launchHelpWindow$$($url$$66$$) {
  var $helpWindowName$$ = $AdfDomUtils$$.$_getHelpWindowName$();
  null == $helpWindowName$$ && ($helpWindowName$$ = "RCFHelpWindow", $AdfDomUtils$$.$_setHelpWindowName$($helpWindowName$$));
  window.open($url$$66$$, $helpWindowName$$, "width\x3d650,height\x3d450,resizable\x3dyes,scrollbars\x3dyes,alwaysRaised").focus();
};
$goog$exportSymbol$$("AdfDomUtils.launchHelpWindow", $AdfDomUtils$$.$launchHelpWindow$);
$AdfDomUtils$$.$writeAttributesToElement$ = function $$AdfDomUtils$$$$writeAttributesToElement$$($domElement$$606$$, $attributesMap$$2$$) {
  var $agent$$771$$ = $AdfAgent$$.$AGENT$, $attribute$$5$$;
  for ($attribute$$5$$ in $attributesMap$$2$$) {
    var $value$$271$$ = $attributesMap$$2$$[$attribute$$5$$];
    void 0 != $value$$271$$ && $agent$$771$$.setAttribute($domElement$$606$$, $attribute$$5$$, $value$$271$$);
  }
};
$goog$exportSymbol$$("AdfDomUtils.writeAttributesToElement", $AdfDomUtils$$.$writeAttributesToElement$);
$AdfDomUtils$$.$copyAllAttributes$ = function $$AdfDomUtils$$$$copyAllAttributes$$($sourceElement$$3$$, $targetElement$$43$$) {
  for (var $i$$706$$ = 0;$i$$706$$ < $sourceElement$$3$$.attributes.length;$i$$706$$++) {
    var $attr$$7$$ = $sourceElement$$3$$.attributes[$i$$706$$];
    $targetElement$$43$$.setAttribute($attr$$7$$.nodeName, $attr$$7$$.value);
  }
};
$goog$exportSymbol$$("AdfDomUtils.copyAllAttributes", $AdfDomUtils$$.$copyAllAttributes$);
$AdfDomUtils$$.$getPopupAncestor$ = function $$AdfDomUtils$$$$getPopupAncestor$$($component$$2321$$) {
  var $parent$$74$$ = null;
  try {
    $parent$$74$$ = $component$$2321$$.getParent();
  } catch ($err$$14$$) {
  }
  if (null == $parent$$74$$) {
    return null;
  }
  for (;null != $parent$$74$$;) {
    if ($parent$$74$$ instanceof AdfRichPopup) {
      return $parent$$74$$;
    }
    try {
      $parent$$74$$ = $parent$$74$$.getParent();
    } catch ($err$$15$$) {
      return !1;
    }
    if (null == $parent$$74$$) {
      return !1;
    }
  }
};
$goog$exportSymbol$$("AdfDomUtils.getPopupAncestor", $AdfDomUtils$$.$getPopupAncestor$);
$AdfDomUtils$$.$isInPopup$ = function $$AdfDomUtils$$$$isInPopup$$($component$$2322_popupAncestor$$) {
  $component$$2322_popupAncestor$$ = $AdfDomUtils$$.$getPopupAncestor$($component$$2322_popupAncestor$$);
  return null == $component$$2322_popupAncestor$$ ? null : 0 == $component$$2322_popupAncestor$$ ? !1 : !0;
};
$goog$exportSymbol$$("AdfDomUtils.isInPopup", $AdfDomUtils$$.$isInPopup$);
$AdfDomUtils$$.$_getHelpWindowName$ = function $$AdfDomUtils$$$$_getHelpWindowName$$() {
  for (var $nameEQ$$ = $AdfDomUtils$$.$_HELP_WINDOW_NAME_COOKIE$ + "\x3d", $ca$$ = document.cookie.split(";"), $caLen$$ = $ca$$.length, $i$$707$$ = 0;$i$$707$$ < $caLen$$;$i$$707$$++) {
    for (var $c$$35$$ = $ca$$[$i$$707$$], $strIdx$$ = 0;" " == $c$$35$$.charAt($strIdx$$);) {
      $strIdx$$++;
    }
    $c$$35$$ = $c$$35$$.substring($strIdx$$, $c$$35$$.length);
    if (0 == $c$$35$$.indexOf($nameEQ$$)) {
      return $c$$35$$.substring($nameEQ$$.length, $c$$35$$.length);
    }
  }
  return null;
};
$AdfDomUtils$$.$_setHelpWindowName$ = function $$AdfDomUtils$$$$_setHelpWindowName$$($windowName$$4$$) {
  document.cookie = $AdfDomUtils$$.$_HELP_WINDOW_NAME_COOKIE$ + "\x3d" + $windowName$$4$$ + "; ; path\x3d/";
};
$AdfDomUtils$$.$_setTextAndAccessKeySpan$ = function $$AdfDomUtils$$$$_setTextAndAccessKeySpan$$($component$$2323_doc$$68$$, $domElement$$607$$, $accessKeyValue$$3$$, $accessKeySpan$$1$$, $newValue$$184$$) {
  var $style$$43$$ = $AdfAgent$$.$AGENT$.$getExpandoProperty$($domElement$$607$$, "_adfAccessKeyStyleClass", null);
  if (null == $style$$43$$) {
    $AdfDomUtils$$.$_setTextContent$($domElement$$607$$, $newValue$$184$$);
  } else {
    var $index$$218$$ = $newValue$$184$$.indexOf($accessKeyValue$$3$$);
    if (0 <= $index$$218$$) {
      if (0 < $index$$218$$) {
        $AdfAgent$$.$AGENT$.$setTextContent$($domElement$$607$$, $newValue$$184$$.substring(0, $index$$218$$));
      } else {
        for (;null != $domElement$$607$$.lastChild;) {
          $domElement$$607$$.removeChild($domElement$$607$$.lastChild);
        }
      }
      $component$$2323_doc$$68$$ = $component$$2323_doc$$68$$.$getPeer$().$getDomDocument$();
      $accessKeySpan$$1$$ = $component$$2323_doc$$68$$.createElement("SPAN");
      $accessKeySpan$$1$$.className = $style$$43$$;
      $AdfAgent$$.$AGENT$.$setTextContent$($accessKeySpan$$1$$, $accessKeyValue$$3$$);
      $domElement$$607$$.appendChild($accessKeySpan$$1$$);
      $index$$218$$ + 1 < $newValue$$184$$.length && $domElement$$607$$.appendChild($component$$2323_doc$$68$$.createTextNode($newValue$$184$$.substr($index$$218$$ + 1)));
    } else {
      $AdfAgent$$.$AGENT$.$setTextContent$($domElement$$607$$, $newValue$$184$$);
    }
  }
  return !0;
};
$AdfDomUtils$$.$_removeSiblings$ = function $$AdfDomUtils$$$$_removeSiblings$$($domElement$$608$$) {
  for (var $node$$147$$, $parent$$75$$ = $domElement$$608$$.parentNode;null != ($node$$147$$ = $domElement$$608$$.previousSibling);) {
    $parent$$75$$.removeChild($node$$147$$);
  }
  for (;null != ($node$$147$$ = $domElement$$608$$.nextSibling);) {
    $parent$$75$$.removeChild($node$$147$$);
  }
};
$AdfDomUtils$$.$_setTextContent$ = function $$AdfDomUtils$$$$_setTextContent$$($domElement$$609$$, $value$$272$$) {
  "BUTTON" == $domElement$$609$$.tagName ? $AdfAgent$$.$AGENT$.$setButtonTextContent$($domElement$$609$$, $value$$272$$) : $AdfAgent$$.$AGENT$.$setTextContent$($domElement$$609$$, $value$$272$$);
};
$AdfDomUtils$$.$_removeAccessKeyElement$ = function $$AdfDomUtils$$$$_removeAccessKeyElement$$($domElement$$610$$, $accessKeyElement$$1$$) {
  $AdfAgent$$.$AGENT$.$setExpandoProperty$($domElement$$610$$, "_adfAccessKeyStyleClass", $accessKeyElement$$1$$.className);
  $accessKeyElement$$1$$.parentNode.removeChild($accessKeyElement$$1$$);
};
$AdfDomUtils$$.$__componentTextChanged$ = function $$AdfDomUtils$$$$__componentTextChanged$$($component$$2324$$, $domElement$$611$$, $newValue$$185$$, $oldValue$$113_spanElement$$2$$) {
  if (null != $oldValue$$113_spanElement$$2$$) {
    $oldValue$$113_spanElement$$2$$ = $AdfDomUtils$$.$getFirstDescendentElement$($domElement$$611$$, "SPAN");
    var $accessKeySpan$$2_accessKeyValue$$4$$ = $component$$2324$$.getPropertyValue("accessKey"), $accessKeySpan$$2_accessKeyValue$$4$$ = null == $accessKeySpan$$2_accessKeyValue$$4$$ ? null : $AdfDomUtils$$.$findAccessKeyDom$($domElement$$611$$, $accessKeySpan$$2_accessKeyValue$$4$$);
    return $AdfDomUtils$$.$handleTextChangeWithAccessKey$($component$$2324$$, $oldValue$$113_spanElement$$2$$ && $oldValue$$113_spanElement$$2$$ != $accessKeySpan$$2_accessKeyValue$$4$$ ? $oldValue$$113_spanElement$$2$$ : $domElement$$611$$, $newValue$$185$$);
  }
  return !1;
};
$AdfDomUtils$$.$componentShowRequiredChanged$ = function $$AdfDomUtils$$$$componentShowRequiredChanged$$($component$$2325_reqIconSpan$$, $domElement$$612$$, $newValue$$186_rawIcon$$2$$) {
  $component$$2325_reqIconSpan$$ = $AdfDomUtils$$.$getFirstElementMatch$($domElement$$612$$, !0, $AdfDomUtils$$.$_matchRequiredIconSpan$);
  if (!$component$$2325_reqIconSpan$$) {
    return !1;
  }
  $newValue$$186_rawIcon$$2$$ ? ($newValue$$186_rawIcon$$2$$ = $AdfPage$$.$PAGE$.$getLookAndFeel$().getIcon("AFRequiredIcon"), $component$$2325_reqIconSpan$$.appendChild($newValue$$186_rawIcon$$2$$)) : $AdfDomUtils$$.$removeAllNodes$($component$$2325_reqIconSpan$$);
  return !0;
};
$goog$exportSymbol$$("AdfDomUtils.componentShowRequiredChanged", $AdfDomUtils$$.$componentShowRequiredChanged$);
$AdfDomUtils$$.$_matchRequiredIconSpan$ = function $$AdfDomUtils$$$$_matchRequiredIconSpan$$($element$$354$$) {
  return "SPAN" == $element$$354$$.tagName && $AdfDomUtils$$.$containsCSSClassName$($element$$354$$, $AdfDomUtils$$.$_REQUIRED_ICON_PLACEHOLDER_STYLE_CLASS$) ? !0 : !1;
};
$AdfDomUtils$$.$_REQUIRED_ICON_PLACEHOLDER_STYLE_CLASS$ = "p_rqi";
$AdfDomUtils$$.$_LEGAL_ELEMENTS$ = {SPAN:1, B:1, A:1, I:1, EM:1, BR:1, HR:1, LI:1, OL:1, UL:1, P:1, TT:1, BIG:1, SMALL:1, PRE:1};
$AdfDomUtils$$.$_LEGAL_ATTRIBUTES$ = {"class":1, style:1, href:1};
$AdfDomUtils$$.$_HELP_WINDOW_NAME_COOKIE$ = "ORA_ADF_HELPWINDOWNAME";
$AdfDomUtils$$.FILTER_ACCEPT = 1;
$goog$exportSymbol$$("AdfDomUtils.FILTER_ACCEPT", $AdfDomUtils$$.FILTER_ACCEPT);
$AdfDomUtils$$.FILTER_REJECT = 0;
$goog$exportSymbol$$("AdfDomUtils.FILTER_REJECT", $AdfDomUtils$$.FILTER_REJECT);
$AdfDomUtils$$.FILTER_SKIP = -1;
$goog$exportSymbol$$("AdfDomUtils.FILTER_SKIP", $AdfDomUtils$$.FILTER_SKIP);
